VERSION 5.00
Begin VB.Form FrmArkanoid 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Arkanoid"
   ClientHeight    =   6735
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   6600
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6735
   ScaleWidth      =   6600
   StartUpPosition =   2  'CenterScreen
   Begin VB.PictureBox PicGame 
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      Height          =   6735
      Left            =   0
      ScaleHeight     =   6735
      ScaleWidth      =   6615
      TabIndex        =   0
      Top             =   0
      Width           =   6615
   End
End
Attribute VB_Name = "FrmArkanoid"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer

Private Declare Function QueryPerformanceCounter Lib "kernel32" (X As Currency) As Boolean
Private Declare Function QueryPerformanceFrequency Lib "kernel32" (lpFrequency As Currency) As Long

Private Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" _
    (ByVal IpszSoundName As String, ByVal uflags As Long) As Long

Private Type Figure
    Left        As Single
    Top         As Single
    Width       As Single
    Height      As Single
    Right       As Single
    Bottom      As Single
    xSpeed      As Single  'For the ball
    ySpeed      As Single  'For the ball
    Picture     As Picture
    GoingLeft   As Boolean 'For the ball
    GoingUp     As Boolean 'For the ball
    Visible     As Boolean 'For the bricks
    Quiet       As Boolean 'For the ball
End Type

Private Enum enuSoundType
    enuGetReady = 0
    enuBrickHit = 1
    enuBarHit = 3
    enuMiss = 4
End Enum

Private Const SND_ASYNC = &H1
Private Const SND_NODEFAULT = &H2
Private Const SND_NOSTOP = &H10        ' don't stop any currently playing sound

'You can change config here
'Ball:
Private Const mCnstBallSpeed     As Single = 1
Private Const mCnstBallWidth     As Single = 14
'Bricks:
Private Const mCnstBrickRows     As Single = 5
Private Const mCnstBrickCols     As Single = 11
Private Const mCnstBrickWidth    As Single = 40
Private Const mCnstBrickHeight   As Single = 20
'Bar:
Private Const mCnstBarHeight     As Single = 20
Private Const mCnstBarWidth      As Single = 80
Private Const mCnstBarSpeed      As Single = 0.5
'---------------------------------------------
Private mBrickCounter            As Integer
Private mBlnrunning              As Boolean

Private Ball                                    As Figure
Private Bar                                     As Figure
Private Scene                                   As Figure
Private Bricks(mCnstBrickRows, mCnstBrickCols)  As Figure

Private Sub Form_Load()
    RestartGame
    Me.Show
    GameLoop
    Set Ball.Picture = Nothing
    Unload Me
End Sub

Private Sub InitValues()
    mBlnrunning = True
    mBrickCounter = mCnstBrickRows * mCnstBrickCols
    PicGame.ScaleMode = vbPixels
    PicGame.AutoRedraw = True
    InitScene
    InitBar             'Setup our Bar
    InitBall            'Setup our Ball
    InitBricks          'Setup all Bricks
End Sub

Private Sub InitScene()
    With Scene
        .Left = 0
        .Top = 0
        .Width = Me.PicGame.ScaleWidth
        .Height = Me.PicGame.ScaleHeight
        .Right = .Left + .Width
        .Bottom = .Top + .Height
    End With
End Sub

Private Sub InitBar()
    With Bar
        .Width = mCnstBarWidth
        .Height = mCnstBarHeight
        .Left = Scene.Width / 2 - .Width / 2
        .Top = Scene.Bottom - .Height
        .Right = .Left + .Width
        .Bottom = .Top + .Height
        .Visible = True
        Set .Picture = LoadPicture(App.Path & "\Images\Bar.JPG")
    End With
End Sub

Private Sub InitBall()
    With Ball
        .Width = mCnstBallWidth
        .Height = mCnstBallWidth
        .Left = Bar.Left + Bar.Width / 2 - .Width / 2
        .Top = Bar.Top - .Height
        .Right = .Left + .Width
        .Bottom = .Top + .Height
        
        .xSpeed = mCnstBallSpeed / 2
        .ySpeed = mCnstBallSpeed / 2
        .GoingLeft = False
        .GoingUp = True
        .Quiet = True
        Set .Picture = LoadPicture(App.Path & "\Images\ball.jpg")
    End With
End Sub

Private Sub InitBricks()
Dim i As Integer, j As Integer
    
    For i = 0 To mCnstBrickRows - 1
        For j = 0 To mCnstBrickCols - 1
            With Bricks(i, j)
                .Width = mCnstBrickWidth
                .Height = mCnstBrickHeight
                .Left = (.Width * j)
                .Top = .Height * (i + 2)
                .Right = .Left + .Width
                .Bottom = .Top + .Height
                .Visible = True
                Set .Picture = LoadPicture(App.Path & "\Images\Brick" & i & ".jpg")
            End With
        Next
    Next
End Sub

Private Sub GameLoop()
Dim iStart As Currency, iEnd As Currency, lRet As Boolean, iFrq As Currency

    lRet = QueryPerformanceFrequency(iFrq)
    Do While mBlnrunning
        lRet = QueryPerformanceCounter(iStart)
        If Abs(iEnd / iFrq - iStart / iFrq) > 0.0001 Then
            CheckKeys
            If Not Ball.Quiet Then
                CheckCollisions
                SetNewPosition  'Set ball position
            End If
            DrawObjects
            lRet = QueryPerformanceCounter(iEnd)
        End If
        DoEvents
    Loop
End Sub

Private Sub CheckKeys()
Dim mLeft       As Boolean 'Bar going left?
Dim mRight      As Boolean 'Bar going Right?
Dim mSpace      As Boolean 'Space pressed?

    mBlnrunning = Not CBool(GetAsyncKeyState(vbKeyEscape))
    mSpace = CBool(GetAsyncKeyState(vbKeySpace))
    mLeft = CBool(GetAsyncKeyState(vbKeyLeft))
    mRight = CBool(GetAsyncKeyState(vbKeyRight))
    
    If mSpace Then
        If Ball.Quiet Then Ball.Quiet = False
    End If
    
    If mLeft And Bar.Left - mCnstBarSpeed > 0 Then
        Bar.Left = Bar.Left - mCnstBarSpeed
        If Ball.Quiet Then Ball.Left = Ball.Left - mCnstBarSpeed
    End If

    If mRight And Bar.Right + mCnstBarSpeed < Scene.Right Then
        Bar.Left = Bar.Left + mCnstBarSpeed
        If Ball.Quiet Then Ball.Left = Ball.Left + mCnstBarSpeed
    End If
    
    Bar.Right = Bar.Left + Bar.Width
    Ball.Right = Ball.Left + Ball.Width
End Sub

Private Sub CheckCollisions()
    CheckCollisionWall          'Check collision between ball and scene (picturebox)
    CheckCollisionBricks        'Check collision between ball and Bricks
    CheckCollisionBar           'Check collision between ball and Bar
End Sub

Private Sub DrawObjects()
    Me.PicGame.Cls
    DrawBall
    DrawBar
    DrawBricks
End Sub

Private Sub DrawBall()
    PicGame.PaintPicture Ball.Picture, Ball.Left, Ball.Top, Ball.Width, Ball.Height
End Sub

Private Sub DrawBar()
    PicGame.PaintPicture Bar.Picture, Bar.Left, Bar.Top, Bar.Width, Bar.Height
End Sub

Private Sub DrawBricks()
Dim i As Integer, j As Integer, lBrick As Figure
    
    For i = 0 To mCnstBrickRows - 1
        For j = 0 To mCnstBrickCols - 1
            lBrick = Bricks(i, j)
            If lBrick.Visible Then
                PicGame.PaintPicture lBrick.Picture, lBrick.Left, lBrick.Top, lBrick.Width, lBrick.Height
            End If
        Next
    Next
End Sub

Private Sub CheckCollisionWall()
'Check if the ball hit the border of the picturebox
    If Ball.GoingLeft And Ball.Left < 0 Then
        Ball.GoingLeft = False
    ElseIf Ball.Right > Scene.Width Then
        Ball.GoingLeft = True
    End If
    
    If Ball.GoingUp And Ball.Top < 0 Then
        Ball.GoingUp = False
    ElseIf Ball.Top > Scene.Height - Ball.Height Then
        PlaySound enuMiss
        InitBall
    End If
End Sub

Private Sub CheckCollisionBricks()
Dim i As Integer, j As Integer
    For i = 0 To mCnstBrickRows - 1
        For j = 0 To mCnstBrickCols - 1
            If Bricks(i, j).Visible Then
                If FunCheckCollision(Ball, Bricks(i, j)) Then ' If there is a collision
                    SetBallDirection Ball, Bricks(i, j)       ' Change ball direction accordingly
                    Bricks(i, j).Visible = False              ' this brick dissapears
                    PlaySound enuBrickHit
                    mBrickCounter = mBrickCounter - 1
                    If mBrickCounter = 0 Then RestartGame
                    Exit Sub
                End If
            End If
        Next
    Next
End Sub

Private Sub RestartGame()
Dim i As Integer, j As Integer
    
    PlaySound enuGetReady
    mBrickCounter = mCnstBrickRows * mCnstBrickCols
    For i = 0 To mCnstBrickRows - 1
        For j = 0 To mCnstBrickCols - 1
            Bricks(i, j).Visible = True
        Next
    Next
    InitValues
End Sub

Private Sub CheckCollisionBar()
Dim DeltaX As Single

    If Ball.GoingUp Then Exit Sub
    If FunCheckCollision(Ball, Bar) Then 'If there is a collision
        If (Ball.Left + Ball.Width / 2) > (Bar.Left + Bar.Width / 2) Then   'Collision Right half of Bar
            DeltaX = (Bar.Right - (Ball.Left + Ball.Width / 2)) / (Bar.Width / 2)
            If DeltaX < 0.3 Then DeltaX = 0.3       'If too close to right border, use 0.3
            Ball.ySpeed = mCnstBallSpeed * DeltaX   'Get new ySpeed
            Ball.GoingLeft = False
        Else
            DeltaX = ((Ball.Left + Ball.Width / 2) - Bar.Left) / (Bar.Width / 2) ' Collision Left half of Bar
            If DeltaX < 0.3 Then DeltaX = 0.3       'If too close to left border, use 0.3
            Ball.ySpeed = mCnstBallSpeed * DeltaX   'Get new ySpeed
            Ball.GoingLeft = True
        End If
        Ball.xSpeed = mCnstBallSpeed - Ball.ySpeed  'Get new xSpeed
        PlaySound enuBarHit
        Ball.GoingUp = True
    End If
End Sub

Private Sub SetBallDirection(pFigure1 As Figure, pFigure2 As Figure)
'Get new direction according to direction before this bounce
    Select Case True
        Case pFigure1.GoingLeft And pFigure1.GoingUp
            If (pFigure2.Bottom - pFigure1.Top) < (pFigure2.Right - pFigure1.Left) Then
                pFigure1.GoingUp = False
            Else
                pFigure1.GoingLeft = False
            End If
            
        Case pFigure1.GoingLeft And Not pFigure1.GoingUp
            If (pFigure1.Bottom - pFigure2.Top) < (pFigure2.Right - pFigure1.Left) Then
                pFigure1.GoingUp = True
            Else
                pFigure1.GoingLeft = False
            End If
            
        Case Not pFigure1.GoingLeft And pFigure1.GoingUp
            If (pFigure2.Bottom - pFigure1.Top) < (pFigure1.Right - pFigure2.Left) Then
                pFigure1.GoingUp = False
            Else
                pFigure1.GoingLeft = True
            End If
            
        Case Not pFigure1.GoingLeft And Not pFigure1.GoingUp
            If (pFigure1.Bottom - pFigure2.Top) < (pFigure1.Right - pFigure2.Left) Then
                pFigure1.GoingUp = True
            Else
                pFigure1.GoingLeft = True
            End If
    End Select
End Sub

Private Function FunCheckCollision(pFigure1 As Figure, pFigure2 As Figure) As Boolean
'Check for a collision in the next move, not this one, so the ball doesnt goes inside the brick
    If Not (pFigure1.Left + pFigure1.xSpeed > pFigure2.Right Or _
            pFigure1.Right + pFigure1.xSpeed < pFigure2.Left Or _
            pFigure1.Top + pFigure1.ySpeed > pFigure2.Bottom Or _
            pFigure1.Bottom + pFigure1.ySpeed < pFigure2.Top) Then
        FunCheckCollision = True
    End If
End Function

Private Sub SetNewPosition()
'Set New Position according to current ball speed and direction
    If Ball.GoingLeft Then
        Ball.Left = Ball.Left - Ball.xSpeed
    Else
        Ball.Left = Ball.Left + Ball.xSpeed
    End If
    Ball.Right = Ball.Left + Ball.Width
    
    If Ball.GoingUp Then
        Ball.Top = Ball.Top - Ball.ySpeed
    Else
        Ball.Top = Ball.Top + Ball.ySpeed
    End If
    Ball.Bottom = Ball.Top + Ball.Height
End Sub

Private Sub PlaySound(pSoundType As enuSoundType)
    Select Case pSoundType
        Case enuSoundType.enuGetReady
            sndPlaySound App.Path & "\Sounds\GetReady.wav", SND_ASYNC Or SND_NODEFAULT Or SND_NOSTOP
        Case enuSoundType.enuBrickHit
            sndPlaySound App.Path & "\Sounds\ReboundBrick.wav", SND_ASYNC
        Case enuSoundType.enuBarHit
            sndPlaySound App.Path & "\Sounds\BarHit.wav", SND_ASYNC Or SND_NODEFAULT
        Case enuSoundType.enuMiss
            sndPlaySound App.Path & "\Sounds\Miss.wav", SND_ASYNC Or SND_NODEFAULT
    End Select
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    mBlnrunning = False
    Erase Bricks
    DoEvents
End Sub


